import("stdfaust.lib");

//second order rc low-pass filter
secondorder(f0, Vin) = wd.buildtree(connectionTree)
with {
    //declare nodes based on components
    r1(i) = wd.resistor(i, R1); 
    c2(i) = wd.capacitor_Vout(i, C2);
    vin(i) = wd.u_voltage(i, Vin);

    R2 = R1; 
    R1 = 1*10^3; 

    C2 = C1; 
    C1 = 1/f0*1.62*10^-4; 
    
    //declare connection tree-meta programming
    connectionTree = vin : (wd.series : (r1, c2));
};

cutoff = hslider("cutoff Frequency", 1000, 20, 20000, 1);
process = no.noise : secondorder(cutoff);

